#!/usr/bin/env python
# -*- coding: latin-1 -*-

import time

class Message:
	""" Message object that gets instatiated with the local time of the OS """
	def __init__(self):
		self.time = time.time()


# ===========================  Messages from Server to Client  ===============
class SC_BatPosition(Message):
	""" A message that contains a bats' position and speed """
	def __init__(self, pos, speed, angle, acc=0):
		Message.__init__(self)
		self.pos = pos
		self.speed = speed
		self.angle = angle
		self.acc = acc

class SC_BallPosition(Message):
	""" A message that contains the balls' position and speed """
	def __init__(self, pos):
		Message.__init__(self)
		self.pos = pos
	
class SC_SetPosition(Message):
	""" A message that sets the position """
	def __init__(self, pos):
		Message.__init__(self)
		self.pos = pos

class SC_Score(Message):
	""" A message that updates the score """
	def __init__(self, player, score):
		self.player = player
		self.score = score

# ===========================  Messages from Client to Server  ===============
class CS_MoveBat(Message):
	""" A message that contains a bats' position and speed """
	def __init__(self, pos, speed, angle, acc=0):
		Message.__init__(self)
		self.pos = pos
		self.speed = speed
		self.angle = angle
		self.acc = acc

class CS_Movement(Message):
	""" Message that tells to which direction a player moves """
	def __init__(self, dir):
		Message.__init__(self)
		self.dir = dir
