#!/usr/bin/env python
# -*- coding: latin-1 -*-

# Imports
import math
import server
import player
import messages
from numarray import array

# =================  BAT ===================
class BatReplicator:
	""" Class that replicates the bats' position """
	def __init__(self, owner):
		""" Inits a batreplicator with an associated owner, the owner is
		    needed to get access to the network. It sets speed and position
			 to default values """
		self.owner = owner
		self.pos = 320, 240
		self.speed = 3, 3
		self.sender = None

	def setSender(self, sender):
		""" Sets the sender object """ 
		print 'Setting sender to:', sender
		self.sender = sender

	def setPosition(self, pos):
		""" Set a new position to the bat """
		# If message is from server, make a SC_ message, else make a CS_ message
		message = messages.SC_SetPosition(pos)
		message.sender = self.sender
		self.owner.network.sendMessage(message)

	def setMovement(self, dir):
		""" Send a movement message to the server """
		message = messages.CS_Movement(dir)
		self.owner.network.sendMessage(message)



# ================= BALL ===================
class BallReplicator:
	""" Class that replicates the balls' position """
	def __init__(self, owner):
		""" Inits a ballreplicator with an associated owner, the owner is
			needed to get access to the network. It sets speed and position
			to default values """
		self.owner = owner
		self.pos = 300, 150
		self.speed = 3
	
	def setPosition(self, pos):
		""" Set a new position to the ball """
		message = messages.SC_BallPosition(pos)
		self.owner.network.sendMessage(message)

	def setScore(self, player, score):
		""" Update score to players """
		message = messages.SC_Score(player, score)
		self.owner.network.sendMessage(message)
	

