#!/usr/bin/env python
# -*- coding: latin-1 -*-


# Imports
import playerstate

class Ringbuffer:
	""" Class that stores player states in a ringbuffer """
	
	def __init__(self, size = 4):
		""" Initialize a buffer """
		self.data = [playerstate.PlayerState() for x in range(0, size)]
		self.max = size

	def append(self, x):
		""" Add a new player state to the ringbuffer """
		tmp = self.data[1:]
		tmp.append(x)
		self.data = tmp

	def get(self):
		""" Get the elements in the ringbuffer """
		return self.data[::-1]

	def getFirst(self):
		""" Get the first element in the ringbuffer, last in terms of time """
		return self.data[self.max - 1]

	def debugRB(self):
		""" Debug method """
		print "DEBUG RB"
		for ps in self.data:
			print ps.debugPS()
		print "DEBUG RB END"
		

